#ifndef __OEM_DBG__H__
#define __OEM_DBG__H__

#define DBG_MESG        0

#define DEG_HID_KEY_MAX 1


#if (DBG_MESG == 1)
    #define DEBUG_Heart     1
    #define DEBUG_IO        0
    #define DEBUG_MAIN      1
    #define DEBUG_KB        0
    #define DEBUG_FLASH     0
    #define DEBUG_Armoury   1
    #define DEBUG_QEI       0
    #define DEBUG_USBCORE   0
    #define DEBUG_OBFUNCTION 0
    #define DEBUG_Effect    0
    #define DEBUG_RF        0
#endif


#if defined(DEBUG_Heart) && (DEBUG_Heart == 1) && (DBG_MESG == 1)
    #define DBG_puts_Heart(x)       DBG_puts(x)
    #define DBG_char_Heart(x)       DBG_char(x)
    #define DBG_byte_Heart(x)       DBG_byte(x)
    #define DBG_word_Heart(x)       DBG_word(x)
    #define DBG_dword_Heart(x)      DBG_dword(x)
#else
    #define DBG_puts_Heart(x)
    #define DBG_char_Heart(x)
    #define DBG_byte_Heart(x)
    #define DBG_word_Heart(x)
    #define DBG_dword_Heart(x)
#endif

#if defined(DEBUG_IO) && (DEBUG_IO == 1) && (DBG_MESG == 1)
    #define DBG_puts_IO(x)      DBG_puts(x)
    #define DBG_char_IO(x)      DBG_char(x)
    #define DBG_byte_IO(x)      DBG_byte(x)
    #define DBG_word_IO(x)      DBG_word(x)
    #define DBG_dword_IO(x)     DBG_dword(x)
#else
    #define DBG_puts_IO(x)
    #define DBG_char_IO(x)
    #define DBG_byte_IO(x)
    #define DBG_word_IO(x)
    #define DBG_dword_IO(x)
#endif

#if defined(DEBUG_MAIN) && (DEBUG_MAIN == 1) && (DBG_MESG == 1)
    #define DBG_puts_MAIN(x)        DBG_puts(x)
    #define DBG_char_MAIN(x)        DBG_char(x)
    #define DBG_byte_MAIN(x)        DBG_byte(x)
    #define DBG_word_MAIN(x)        DBG_word(x)
    #define DBG_dword_MAIN(x)       DBG_dword(x)
#else
    #define DBG_puts_MAIN(x)
    #define DBG_char_MAIN(x)
    #define DBG_byte_MAIN(x)
    #define DBG_word_MAIN(x)
    #define DBG_dword_MAIN(x)
#endif

#if defined(DEBUG_KB) && (DEBUG_KB == 1) && (DBG_MESG == 1)
    #define DBG_puts_KB(x)      DBG_puts(x)
    #define DBG_char_KB(x)      DBG_char(x)
    #define DBG_byte_KB(x)      DBG_byte(x)
    #define DBG_word_KB(x)      DBG_word(x)
    #define DBG_dword_KB(x)     DBG_dword(x)
#else
    #define DBG_puts_KB(x)
    #define DBG_char_KB(x)
    #define DBG_byte_KB(x)
    #define DBG_word_KB(x)
    #define DBG_dword_KB(x)
#endif

#if defined(DEBUG_FLASH) && (DEBUG_FLASH == 1) && (DBG_MESG == 1)
    #define DBG_puts_FLASH(x)       DBG_puts(x)
    #define DBG_char_FLASH(x)       DBG_char(x)
    #define DBG_byte_FLASH(x)       DBG_byte(x)
    #define DBG_word_FLASH(x)       DBG_word(x)
    #define DBG_dword_FLASH(x)      DBG_dword(x)
#else
    #define DBG_puts_FLASH(x)
    #define DBG_char_FLASH(x)
    #define DBG_byte_FLASH(x)
    #define DBG_word_FLASH(x)
    #define DBG_dword_FLASH(x)
#endif

#if defined(DEBUG_Armoury) && (DEBUG_Armoury == 1) && (DBG_MESG == 1)
    #define DBG_puts_Armoury(x)     DBG_puts(x)
    #define DBG_char_Armoury(x)     DBG_char(x)
    #define DBG_byte_Armoury(x)     DBG_byte(x)
    #define DBG_word_Armoury(x)     DBG_word(x)
    #define DBG_dword_Armoury(x)    DBG_dword(x)
#else
    #define DBG_puts_Armoury(x)
    #define DBG_char_Armoury(x)
    #define DBG_byte_Armoury(x)
    #define DBG_word_Armoury(x)
    #define DBG_dword_Armoury(x)
#endif

#if defined(DEBUG_QEI) && (DEBUG_QEI == 1) && (DBG_MESG == 1)
    #define DBG_puts_QEI(x)     DBG_puts(x)
    #define DBG_char_QEI(x)     DBG_char(x)
    #define DBG_byte_QEI(x)     DBG_byte(x)
    #define DBG_word_QEI(x)     DBG_word(x)
    #define DBG_dword_QEI(x)        DBG_dword(x)
#else
    #define DBG_puts_QEI(x)
    #define DBG_char_QEI(x)
    #define DBG_byte_QEI(x)
    #define DBG_word_QEI(x)
    #define DBG_dword_QEI(x)
#endif

#if defined(DEBUG_USBCORE) && (DEBUG_USBCORE == 1) && (DBG_MESG == 1)
    #define DBG_puts_USB(x)     DBG_puts(x)
    #define DBG_char_USB(x)     DBG_char(x)
    #define DBG_byte_USB(x)     DBG_byte(x)
    #define DBG_word_USB(x)     DBG_word(x)
    #define DBG_dword_USB(x)    DBG_dword(x)
#else
    #define DBG_puts_USB(x)
    #define DBG_char_USB(x)
    #define DBG_byte_USB(x)
    #define DBG_word_USB(x)
    #define DBG_dword_USB(x)
#endif

#if defined(DEBUG_OBFUNCTION) && (DEBUG_OBFUNCTION == 1) && (DBG_MESG == 1)
    #define DBG_puts_OBF(x)     DBG_puts(x)
    #define DBG_char_OBF(x)     DBG_char(x)
    #define DBG_byte_OBF(x)     DBG_byte(x)
    #define DBG_word_OBF(x)     DBG_word(x)
    #define DBG_dword_OBF(x)    DBG_dword(x)
#else
    #define DBG_puts_OBF(x)
    #define DBG_char_OBF(x)
    #define DBG_byte_OBF(x)
    #define DBG_word_OBF(x)
    #define DBG_dword_OBF(x)
#endif

#if defined(DEBUG_Effect) && (DEBUG_Effect == 1) && (DBG_MESG == 1)
    #define DBG_puts_Effect(x)      DBG_puts(x)
    #define DBG_char_Effect(x)      DBG_char(x)
    #define DBG_byte_Effect(x)      DBG_byte(x)
    #define DBG_word_Effect(x)      DBG_word(x)
    #define DBG_dword_Effect(x)     DBG_dword(x)
#else
    #define DBG_puts_Effect(x)
    #define DBG_char_Effect(x)
    #define DBG_byte_Effect(x)
    #define DBG_word_Effect(x)
    #define DBG_dword_Effect(x)
#endif

#if defined(DEBUG_RF) && (DEBUG_RF == 1) && (DBG_MESG == 1)
    #define DBG_puts_RF(x)          DBG_puts(x)
    #define DBG_char_RF(x)          DBG_char(x)
    #define DBG_byte_RF(x)          DBG_byte(x)
    #define DBG_word_RF(x)          DBG_word(x)
    #define DBG_dword_RF(x)         DBG_dword(x)
#else
    #define DBG_puts_RF(x)
    #define DBG_char_RF(x)
    #define DBG_byte_RF(x)
    #define DBG_word_RF(x)
    #define DBG_dword_RF(x)
#endif

void DBG_char(unsigned char b);
void DBG_byte(unsigned char b);
void DBG_word(unsigned int w);
void DBG_dword(uint32_t dw);
void DBG_puts(const char* s);

#endif /*__OEM_DBG__H__*/
