/*
*	OEM_UART.C
*
*   OEM service related functions.
*
*	Author: Hugo Lin - Asus
*	email: Hugo_Lin@asus.com
*
*/
#include "usb_firmware_library_headers.h"
#include "hal_defs.h"
#include "hal_mcu.h"
#include "OEM_dbg.h"
#include "OEM_Service.h"
#include "OEM_uart.h"
#include "OEM_timer.h"
#include "usb_hid.h"

volatile Service_Flag  ServiceFlags;
volatile System_Flag  system_flag;

void OEM_main_service(void)
{
    if (ServiceFlags.Service_1ms) {
        EA = 0;
        ServiceFlags.Service_1ms = 0;
        EA = 1;
        check_uart_need_start();
    }
}


