#ifndef OEM_EC_VER_H
#define OEM_EC_VER_H

//Firmware Version (EX:v00.10.21.03 -> 0x00102103)
//            Chip:         ST | TI
//         Version:    (v01.02) (v01.03)

#define FW_VERSION                      0x00000114

#define BLE_VID                         0x0B05
#define BLE_PID                         0x1962
#define BLE_DEVICE_NAME_STR             "ROG KERIS WIRELESS"
#define BLE_DEVICE_NAME                 'R','O','G',' ','K','E','R','I','S'
#define BLE_DEVICE_NAME_LEN             9
#define BLE_SCAN_RSP_LEN                ((1) + (BLE_DEVICE_NAME_LEN))
#define BLE_ADVERT_DEVICE_NAME_LEN      ((6) + (BLE_DEVICE_NAME_LEN))

extern const uint32_t OEM_EC_Ver;
extern const uint32_t OEM_stm32_Ver;

#endif //OEM_EC_VER_H
