#ifndef __OEM_DBG__H__
#define __OEM_DBG__H__

#define DBG_MESG    0

#if (DBG_MESG == 1)
    #define DEBUG_Heart         1
    #define DEBUG_Log           1
    #define DEBUG_MAIN          1
    #define DEBUG_Key           0
    #define DEBUG_SENSOR        1
    #define DEBUG_QEI           0
    #define DEBUG_Armoury       0
    #define DEBUG_OBFUNCTION    0
    #define DEBUG_Effect        1
    #define DEBUG_BLE           1
    #define DEBUG_Flash         0
    #define DEBUG_RF            0
    #define DEBUG_JOYSTICK      0
    #define DEBUG_PWM           1
#endif

#if DEBUG_Heart == 1
    #define DBG_puts_Heart(x)       DBG_puts(x)
    #define DBG_char_Heart(x)       DBG_char(x)
    #define DBG_byte_Heart(x)       DBG_byte(x)
    #define DBG_word_Heart(x)       DBG_word(x)
    #define DBG_dword_Heart(x)      DBG_dword(x)
#else
    #define DBG_puts_Heart(x)
    #define DBG_char_Heart(x)
    #define DBG_byte_Heart(x)
    #define DBG_word_Heart(x)
    #define DBG_dword_Heart(x)
#endif

#if DEBUG_Log == 1
    #define DBG_puts_Log(x)         DBG_puts(x)
    #define DBG_char_Log(x)         DBG_char(x)
    #define DBG_byte_Log(x)         DBG_byte(x)
    #define DBG_word_Log(x)         DBG_word(x)
    #define DBG_dword_Log(x)        DBG_dword(x)
#else
    #define DBG_puts_Log(x)
    #define DBG_char_Log(x)
    #define DBG_byte_Log(x)
    #define DBG_word_Log(x)
    #define DBG_dword_Log(x)
#endif

#if DEBUG_MAIN == 1
    #define DBG_puts_MAIN(x)        DBG_puts(x)
    #define DBG_char_MAIN(x)        DBG_char(x)
    #define DBG_byte_MAIN(x)        DBG_byte(x)
    #define DBG_word_MAIN(x)        DBG_word(x)
    #define DBG_dword_MAIN(x)       DBG_dword(x)
#else
    #define DBG_puts_MAIN(x)
    #define DBG_char_MAIN(x)
    #define DBG_byte_MAIN(x)
    #define DBG_word_MAIN(x)
    #define DBG_dword_MAIN(x)
#endif

#if DEBUG_Key == 1
    #define DBG_puts_Key(x)         DBG_puts(x)
    #define DBG_char_Key(x)         DBG_char(x)
    #define DBG_byte_Key(x)         DBG_byte(x)
    #define DBG_word_Key(x)         DBG_word(x)
    #define DBG_dword_Key(x)        DBG_dword(x)
#else
    #define DBG_puts_Key(x)
    #define DBG_char_Key(x)
    #define DBG_byte_Key(x)
    #define DBG_word_Key(x)
    #define DBG_dword_Key(x)
#endif

#if DEBUG_SENSOR == 1
    #define DBG_puts_SENSOR(x)      DBG_puts(x)
    #define DBG_char_SENSOR(x)      DBG_char(x)
    #define DBG_byte_SENSOR(x)      DBG_byte(x)
    #define DBG_word_SENSOR(x)      DBG_word(x)
    #define DBG_dword_SENSOR(x)     DBG_dword(x)
#else
    #define DBG_puts_SENSOR(x)
    #define DBG_char_SENSOR(x)
    #define DBG_byte_SENSOR(x)
    #define DBG_word_SENSOR(x)
    #define DBG_dword_SENSOR(x)
#endif

#if DEBUG_QEI == 1
    #define DBG_puts_QEI(x)         DBG_puts(x)
    #define DBG_char_QEI(x)         DBG_char(x)
    #define DBG_byte_QEI(x)         DBG_byte(x)
    #define DBG_word_QEI(x)         DBG_word(x)
    #define DBG_dword_QEI(x)        DBG_dword(x)
#else
    #define DBG_puts_QEI(x)
    #define DBG_char_QEI(x)
    #define DBG_byte_QEI(x)
    #define DBG_word_QEI(x)
    #define DBG_dword_QEI(x)
#endif

#if DEBUG_Armoury == 1
    #define DBG_puts_Armoury(x)     DBG_puts(x)
    #define DBG_char_Armoury(x)     DBG_char(x)
    #define DBG_byte_Armoury(x)     DBG_byte(x)
    #define DBG_word_Armoury(x)     DBG_word(x)
    #define DBG_dword_Armoury(x)    DBG_dword(x)
#else
    #define DBG_puts_Armoury(x)
    #define DBG_char_Armoury(x)
    #define DBG_byte_Armoury(x)
    #define DBG_word_Armoury(x)
    #define DBG_dword_Armoury(x)
#endif

#if DEBUG_OBFUNCTION == 1
    #define DBG_puts_OBF(x)         DBG_puts(x)
    #define DBG_char_OBF(x)         DBG_char(x)
    #define DBG_byte_OBF(x)         DBG_byte(x)
    #define DBG_word_OBF(x)         DBG_word(x)
    #define DBG_dword_OBF(x)        DBG_dword(x)
#else
    #define DBG_puts_OBF(x)
    #define DBG_char_OBF(x)
    #define DBG_byte_OBF(x)
    #define DBG_word_OBF(x)
    #define DBG_dword_OBF(x)
#endif

#if DEBUG_Effect == 1
    #define DBG_puts_Effect(x)      DBG_puts(x)
    #define DBG_char_Effect(x)      DBG_char(x)
    #define DBG_byte_Effect(x)      DBG_byte(x)
    #define DBG_word_Effect(x)      DBG_word(x)
    #define DBG_dword_Effect(x)     DBG_dword(x)
#else
    #define DBG_puts_Effect(x)
    #define DBG_char_Effect(x)
    #define DBG_byte_Effect(x)
    #define DBG_word_Effect(x)
    #define DBG_dword_Effect(x)
#endif

#if DEBUG_BLE == 1
    #define DBG_puts_BLE(x)         DBG_puts(x)
    #define DBG_char_BLE(x)         DBG_char(x)
    #define DBG_byte_BLE(x)         DBG_byte(x)
    #define DBG_word_BLE(x)         DBG_word(x)
    #define DBG_dword_BLE(x)        DBG_dword(x)
#else
    #define DBG_puts_BLE(x)
    #define DBG_char_BLE(x)
    #define DBG_byte_BLE(x)
    #define DBG_word_BLE(x)
    #define DBG_dword_BLE(x)
#endif

#if DEBUG_Flash == 1
    #define DBG_puts_Flash(x)       DBG_puts(x)
    #define DBG_char_Flash(x)       DBG_char(x)
    #define DBG_byte_Flash(x)       DBG_byte(x)
    #define DBG_word_Flash(x)       DBG_word(x)
    #define DBG_dword_Flash(x)      DBG_dword(x)
#else
    #define DBG_puts_Flash(x)
    #define DBG_char_Flash(x)
    #define DBG_byte_Flash(x)
    #define DBG_word_Flash(x)
    #define DBG_dword_Flash(x)
#endif

#if DEBUG_RF == 1
    #define DBG_puts_RF(x)          DBG_puts(x)
    #define DBG_char_RF(x)          DBG_char(x)
    #define DBG_byte_RF(x)          DBG_byte(x)
    #define DBG_word_RF(x)          DBG_word(x)
    #define DBG_dword_RF(x)         DBG_dword(x)
#else
    #define DBG_puts_RF(x)
    #define DBG_char_RF(x)
    #define DBG_byte_RF(x)
    #define DBG_word_RF(x)
    #define DBG_dword_RF(x)
#endif

#if DEBUG_JOYSTICK == 1
    #define DBG_puts_Joystick(x)    DBG_puts(x)
    #define DBG_char_Joystick(x)    DBG_char(x)
    #define DBG_byte_Joystick(x)    DBG_byte(x)
    #define DBG_word_Joystick(x)    DBG_word(x)
    #define DBG_dword_Joystick(x)   DBG_dword(x)
#else
    #define DBG_puts_Joystick(x)
    #define DBG_char_Joystick(x)
    #define DBG_byte_Joystick(x)
    #define DBG_word_Joystick(x)
    #define DBG_dword_Joystick(x)
#endif

#if DEBUG_PWM == 1
    #define DBG_puts_PWM(x)         DBG_puts(x)
    #define DBG_char_PWM(x)         DBG_char(x)
    #define DBG_byte_PWM(x)         DBG_byte(x)
    #define DBG_word_PWM(x)         DBG_word(x)
    #define DBG_dword_PWM(x)        DBG_dword(x)
#else
    #define DBG_puts_PWM(x)
    #define DBG_char_PWM(x)
    #define DBG_byte_PWM(x)
    #define DBG_word_PWM(x)
    #define DBG_dword_PWM(x)
#endif


void DBG_char( unsigned char b );
void DBG_byte( unsigned char b );
void DBG_word( unsigned int w );
void DBG_dword( uint32_t dw );
void DBG_puts( const char* s );

#endif /*__OEM_DBG__H__*/
