#ifndef __OEM_UART_H__
#define __OEM_UART_H__

#include <ti/drivers/UART.h>

extern UART_Handle uart;
extern uint8_t uart_tx_need_check;

void OEM_UART_Init(void);
void OEM_UART_Sleep_Mode_Init(void);
void OEM_UART_DeInit(void);
void uart_send_fifo(uint8_t buf);
void check_uart_need_start(void);

#endif
